---
title: Rax 系列教程（国际化 - 本地化部分）
date: 20180319
author: 星啸
---

# Rax 系列教程（国际化 - 本地化部分）

## [](#0)1\. 引子

为什么需要国际化？

对国际业务场景而言，我们的用户群体已经不是单一的区域或者国家群众。以ICBU的买家APP为例，服务约100个不同国家，支持16种语种切换，并且在实践过程中，从APP应用商店的用户反馈中，也可以发现多语言本地化对用户的体验能够带来极大的提升。目前ICBU买家APP内非场馆统计多语种用户的浏览量为50%以上。

同时也可以参考一些相关数据：

*   国际化网站的多语言支持：雅虎、谷歌、amazon、AliExpress雅虎、google基本是每个国家地区都有多语言的支持AE使用的是多语言支持的方式：约支持100+种语言切换Amazon使用的是国家站的支持方式：约有14个不同国家的国家站
*   与应用商店的合作，例如本地化后更有可能获得google play的编辑推荐，[一些网上的说明](https://www.baijingapp.com/article/3629)
*   从ICBU的业务数据来看，多语言场馆的转化率比英文场馆转化率要高

基本上，对于需要面向国际用户的APP而言，无论是出于提升用户体验还是获取相关平台支持的考虑，本地化是必不可少的一环。

当然，本地化是国际化中的其中一环。国际化可以细分为本地化以及组件分端UI这两部分，这篇文章主要是描述ICBU中国际化的本地化部分的一些实践经验以及选型思考。

后续会有《Rax 系列教程（国际化 - 组件分端UI）》- 关于Android MD风格以及IOS以及Iphone X相关组件分端UI注意事项和实践经验。

## [](#1)2\. 业内方案分析，与我们的思考

在调研阶段，我们发现多语言有以下几种做法。

*   A：文案和业务代码一同构建，每个语言一个bundle发布到静态集群，最后在用户请求URL的时候，根据UA下发不同的语言。
*   B：文案和业务代码一同构建，所有语言一个bundle发布到静态集群，代码下发到APP运行时根据APP内环境展示不同的文案。
*   C：构建时不包含文案，只包含文案的key。APP拉取文案包缓存在本地，最后在代码运行时在从APP中拉取文案内容并且展示。
*   D：构建时不包含文案，只包含文案的key。代码运行时异步从服务器拉取多语言文案并且展示。


| 方案 | APP改造 | 服务端改造 | 构建器脚手架改造 | 使用方 |
| --- | --- | --- | --- | --- |
| A | 网络请求改造 | 判断UA下发不同文件 | 构建多套文案 | rax多语言 |
| B | 提供查询语言能力 | - | - | ICBU买家APP |
| C | 文案缓存以及读取 | 推送文案包到APP的能力 | - | 暂无 |
| D | 提供查询语言能力 | 提供按key下发文案的接口 | - | ICBU部分七巧板应用 |


ICBU使用的方案和rax-i18n的思路不太一样，并不是发N份不同语种的js bundle到air，然后air判别UA来返回不同语言的bundle。

ICBU的WEEX多语言方案是一直只有唯一的一份bundle，而这份bundle包含了所有的语言文案。这样做虽然在代码体积上会有稍微的提升，但是考虑到无线端运营场馆的静态文案量少（通常在10句以内），同时该方案可以支持场馆内直接切换语言的操作，同时客户端和数据统计上的改造成本比较低，因此使用了B这套方案。

## [](#2)3\. ICBU对本地化处理的WEEX实践

效果如下：

以下有一些术语需要先解释：

1.  美杜莎：ICBU这边选用的多语言管理平台，并且打通了前端发布体系和APP语言下发体系
2.  air平台：终端业务平台，集成了WEEX体系下常用的平台
3.  IKE: ICBU内基于RAX做的业务组件封装
4.  just：ICBU选用的前端工程体系
5.  OCMS：ICBU选用的可视化搭建平台，提供给运营搭建页面使用
6.  work平台：ICBU选用的数据集合平台，个人理解和淘系的命运石系统是同类型产品（以上均为个人理解，如有不当，烦请指教）

### [](#3)3.0 ICBU的I18N组件

参考自rax的i18n组件，结合ICBU的APP能力以及上层搭建平台的WEEX多语言处理组件。根据APP提供的本地化信息，自动适配R2L布局，获取对应语种文案，格式化对应区域时间等功能。

### [](#4)3.1 静态文案下发方案

效果图如下：

![img](//ata2-img.cn-hangzhou.img-pub.aliyun-inc.com/a8379be1d5df03c9e765ce4627022a9f.png "img")]

![img](//ata2-img.cn-hangzhou.img-pub.aliyun-inc.com/53c20a3e7347c2dc90713bc9c84ef25c.png "img")]

![img](//ata2-img.cn-hangzhou.img-pub.aliyun-inc.com/7c287e79e5999018cc4cf1220a36c227.png "img")]

静态文案指的是前端会写死在页面中的固定文案，常见的如Loading、End、Price、See More、Terms & Conditions等文案。ICBU的静态文案的获取思路是运营或PD预先在美杜莎（或者其他多语言平台）中录入文案，并且以tnpm包的方式发布。前端把该文案包打包进业务代码内。而在前端代码中通过key调用即可。

【前后对比如下】

改造前：copy文案团队 —> 前端 —> 前端根据交互稿写死文案 —>发布页面

改造后：copy文案团队 —>美杜莎 —> 前端根据交互稿写死文案对应的key，把文案包下载到本地 —> 发布页面

### [](#5)3.2 组件搭建体系下静态文案方案

3.1中描述的静态文案下发是基于文案比较固定，即业务对文案修改不频繁的情况而言的。而对于像大促的情况，运营可能在活动期间会根据数据效果做不同的调整，如果每次都需要前端介入，那么效率就会极低。因此在ICBU实践中，OCMS搭建平台打通了美杜莎，把“ 前端根据交互稿写死文案对应的key，把文案包下载到本地”的这一步，更变为：前端预先写好配置的key，而文案包的下载与打包交由积木盒子进行。

copy —>美杜莎 —> 前端根据交互稿写死文案对应的key，把文案包下载到本地 —> 发布页面

### [](#6)3.3 动态文案下发方案（产品等信息）

![img](//ata2-img.cn-hangzhou.img-pub.aliyun-inc.com/49a68f901da8a4016cfdc43dbe228f44.png "img")]

动态文案通常指**产品信息、货币信息、类目**等由服务端动态下发的文案。

和lazada一样，ICBU的动态文案投放依赖于数据方（如数据投放系统work平台或者业务后端）。此处不做过多展开，但在实践中有几点注意事项：

1.  动态文案的布局。

    由于动态文案布局也有可能涉及到R2L问题，因此对动态文案，建议包裹在会处理布局的View（例如ICBU的`I18nView`）中，自动做文案的布局转换。如下图

![img](//ata2-img.cn-hangzhou.img-pub.aliyun-inc.com/4a9f911c384ec3069f30ef964307d479.png "img")]

![img](//ata2-img.cn-hangzhou.img-pub.aliyun-inc.com/2719be37b1cdb2b89725db3530f68809.png "img")]

1.  动态文案在mtop和在一般jsonp接口的使用方式。

    对于mtop接口，语言类型会随请求自动发出，对前端透明。而对业务一直沿用的jsonp接口，则需要前端把语言信息也一并传入。

### [](#7)3.4 Banner（图文分离多语言）

Banner类型需要做多语言的方式有两种，一种是**对Banner做图文分离实现所有语种多语言**。一种是**只对核心语言做多语言Banner**。两者各有好处，对Banner做图文分离实现所有语种多语言可以做到全语种覆盖，然而文案会因为不同语种的长度问题引起视觉上的问题，例如文案无法展示完全等问题。而只对核心语言做多语言Banner（即UED出多套语言的banner）则是无法做到全语种覆盖，且运营成本也会变得更高，但可以对核心用户群体提供更好的体验。目前ICBU选用的方案为第一种，对Banner做图文分离实现所有语种多语言。

多语言的场景在无线越铺越开，原来可以通过图片来展示的场景。都需要做图文分离（典型如banner、或者一些介绍LP页面）需要前端介入。这里包含了两个部分，一是有没有的问题，一个是效率的问题。

“有没有”的问题在于目前banner都是由UED统一设计好再交付的，而UED在设计的时候，通常是以英语去做设计的，如果不做图文分离，那么对于多语言场馆而言，用户第一眼看到的就是英文banner，然后才是本地化的浏览内容。实际效果如下：

![img](//ata2-img.cn-hangzhou.img-pub.aliyun-inc.com/7b83556f20833734a11a12cb69988625.png "img")]

因此图文分离对于本地化的意义是不亚于静态和动态文案下发的研究的。ICBU的实践中，是前端和UED协商好Banner的文字范围，然后UED输出banner底图，运营输出文案，最后由前端去拼合。

另一个是效率问题：纵使UED可以通过一定的规范去输出banner，但是如果每一个图文分离的需求都需要前端介入，重新开发一套模板。那么效率就太低了。在三月大促中，为了部分解决这个问题，开发了基于schema生成图文分离banner的组件。前端只需要大致编写schema，就可以具体生成不同的图文分离组件。具体如下：

![image.png](//ata2-img.cn-hangzhou.img-pub.aliyun-inc.com/f055bff4bb637d507ded54491ded54d1.png "image.png")

### [](#8)3.5 内容资讯文案

内容资讯文案指的是诸如新闻快报、运营资讯等文章内容型的文案。这类型文案无论是机翻还是人工翻译都是成本比较高的，同时更新频率也比较高，因此在ICBU这边的做法是内容型文章暂时不做翻译。

还有一种思路是根据不同的地区国家，去推送不同的内容和语言的资讯。例如中国推送的就是中国运营团队编写的文章，俄罗斯就推俄罗斯的运营团队文章。但这样就对运营团队要求颇高了。

### [](#9)3.6 多币种

本土化中有一个很重要的点是多币种，由于在APP中是可以让用户选择币种。在list和detail中都会出现本土币种的展示。目前ICBU的做法是由无线服务端对接到work平台，提供多币种的查询方式。具体的做法和多语言类似，前端调用windvane接口，获取APP中币种设置，在请求商品信息的时候把币种也带上。目前处于接入阶段。

### [](#10)3.7 本地日期格式

对不同地区的用户来说，日期阅读习惯是不一样的。例如美国（USA）是：mm/dd/yyyy 的阅读习惯，而UK和法国则是 dd/mm/yyyy的阅读习惯。对于这部分的转换，目前ICBU由UED用研团队整理了16个区域的时间格式，并按照不同区域提供不同的日期格式显示。而对于语言、区域以及地区的时间格式，可以参考下表：


| 区域 | 日期格式 | 备注 | ISO 3166标准 | ISO 639标准 | MCMS（美杜莎标准） |
| --- | --- | --- | --- | --- | --- |
| USA | mm/dd/yyyy | en-US | US | en | en-us |
| UK | dd/mm/yyyy | en-GB | GB | en | en-us |
| France | dd/mm/yyyy | fr | FR | fr | fr-fr |
| Spain | dd/mm/yyyy | es | ES | es | es-es |
| India | dd/mm/yyyy | en-IN | IN | en | en-us |
| Indonesia | dd/mm/yyyy | id | ID | id | in-id |
| Brazil | dd/mm/yyyy | pt | PT | pt | pt-pt |
| Turkey | dd/mm/yyyy | tr | TR | tr | tr-tr |
| Pakistan | dd/mm/yyyy | ur | UR | ur | en-us |
| Thailand | dd/mm/yyyy | th | TH | th | th-th |
| Saudi Arabia | dd/mm/yyyy | ar | AR | ar | ar-sa |
| Malaysia | dd/mm/yyyy | ms | MS | ms | ms-my |
| Canada | mm/dd/yyyy | fr-CA | CA | fr | fr-fr |
| China | yyyy/mm/dd | zh-Hans | CN | zh | zh-cn |
| Australia | dd/mm/yyyy | en-AU | AU | en | en-us |
| Germany | dd.mm.yyyy | de | DE | de | de-de |
| Russia | dd.mm.yyyy | ru | RU | ru | ru-ru |
| Japan | yyyy/mm/dd | ja-jp | JP | ja | ja-jp |


## [](#11)4\. APP部分 - 跟应用市场的合作

以下内容为部分APP内产品的本地化实践经验，仅供参考。

*   在对比本地化效果时，效果的判断：对比该地区英语语种和多语言语种的业务数据
*   PC上的，收货地址编辑，可以给地址英文版本，让用户能够看懂地址（google map或者机翻）
*   国家的敏感色（例如俄罗斯对红色的厌恶）
*   Description（最重要的3-5行）多语言产品介绍。
*   分国家的多利益点截图（参考输入法“aka“，美国人、印度人的聊天）
*   SEO的想法：应用市场的评分（体验愉快后，再给用户评价。）
*   用户反馈问题的日报，（及时抓页面反馈）
*   Google play的AB，发现视频效果不怎么好（不清楚原因）动态文案多语言.png多语言镜像翻转.png多语言镜像翻转2.png静态文案多语言.png静态文案多语言2.png静态文案多语言3.png图文分离多语言.png前端schema生成图文排版工具.png